/* 
    channel for Bt848 frame grabber driver

    Copyright (C) 1996,97 Marcus Metzler (mocm@thp.uni-koeln.de)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/*
 * channel.cc 
 */

#include "channel.h"
#include <string.h>

int channel::cnt=0;
bool channel::xtvscreen_file=false;

channel::channel(channel *h,int freq,const char *n,int c,int b,int hu,int co,int no,int in,
		 int start=0,int num=-1)
{
  head=0;
  
  if (num <0 || num>cnt){
    while(h->next) h=h->next;
    h->next=this;
    cnt++;
    number=cnt;  // first element is 1 !!!
    prev=h;
    next=NULL;
  } else {
    while(h->number < (num+1)) h=h->next;
    next=h->next;
      h->next=this;
    next->prev=this;
    cnt++;
    number=num; // number of elemnet, list starts with 1 !!!
    h=this;
    while(h->next) {
      h=h->next;
      h->number++;
    }
  }
  name=new char[strlen(n)+1];
  strcpy(name,n);
  frequency=freq;
  color=c;
  brightness=b;
  hue=hu;
  contrast=co;
  norm=no;
  input=in;
  startwiththis=start;
}


channel::~channel(){
  channel *h=this;
  
  if (!head){
    (h->prev)->next=h->next;
    if (h->next) (h->next)->prev=h->prev;
    delete(name);
    while(h->next) {
      h=h->next;
      h->number--;
    }
    cnt--;
  } else {
    channel *n=this;
    
      while (n->next) {
	(n->next)->~channel();
      }
  }
}

ostream &operator<<(ostream &stream, channel &x)
{
  stream << "*" << endl;
  stream << "Channel: " << x.name << endl;
  stream << "Frequency: " << x.frequency << endl;
  stream << "CBHC: " << x.color << " "; 
  stream << x.brightness << " "; 
  stream << x.hue << " "; 
  stream << x.contrast << endl; 
  stream << "NIS: " << x.norm << " "; 
  stream << x.input << " " << x.startwiththis << endl; 
}

istream &operator>>(istream &stream, channel &x)
{
  char cdummy[50];
  
  if (x.isImport()) {
    stream >> cdummy >> cdummy;
    if (x.name) delete(x.name);
    x.name=new char[sizeof(cdummy)];
    strcpy(x.name,cdummy);
    stream.get(cdummy,sizeof(cdummy)); // get full channel name
    strcat(x.name,cdummy);
    
    stream >> cdummy >> x.frequency >> cdummy >> x.color >> x.brightness;
    stream >> x.hue >> x.contrast >> cdummy >> x.norm >> x.input; 
  } else {
    stream >> cdummy >> cdummy;
    if (x.name) delete(x.name);
    x.name=new char[sizeof(cdummy)];
    strcpy(x.name,cdummy);
    stream.get(cdummy,sizeof(cdummy)); // get full channel name
    strcat(x.name,cdummy);
  
    stream >> cdummy >> x.frequency >> cdummy >> x.color >> x.brightness;
    stream >> x.hue >> x.contrast >> cdummy >> x.norm >> x.input >> x.startwiththis; 
  }
}


