/* 
    channel for Bt848 frame grabber driver

    Copyright (C) 1996,97 Marcus Metzler (mocm@thp.uni-koeln.de)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef _channel_h
#define _channel_h

#include <stdio.h>
#include <stdlib.h>
#include <iostream.h>
#include <fstream.h>
#include <strstream.h>

class channel
{
private:
  static int cnt;
  static bool xtvscreen_file;

public:
  channel *prev;
  channel *next;

  int number;      // number of this element in list
  int head;        // head of list
  
  int frequency;
  char *name;
  int color;
  int brightness;
  int hue;
  int contrast;
  int norm;
  int input;
  int startwiththis;

  // constructors, destructor
  channel(){
    prev=NULL;
    next=NULL;
    number=0;
    head=1;
    //cnt=0;
    startwiththis=0;
  }
  
  channel(channel *h,int freq,const char *n,int c,int b,int hu,int co,int no,int in,
	  int start=0,int num=-1);

  ~channel();

  // streams
  friend ostream &operator<<(ostream &stream, channel &x);
  friend istream &operator>>(istream &stream, channel &x);

  // public functions
  int count() { return cnt; }
  void import(bool on) { xtvscreen_file=on; }
  bool isImport() { return xtvscreen_file; }
};

#endif /* _channel_h */
/* DON'T ADD STUFF AFTER THIS #endif */











