#ifndef colorspace_h
#define colorspace_h

#ifdef __cplusplus
extern "C" {
#endif

void yuv_init(void);

typedef void (*color_conv)(void *d, void *s, int n, int w);

void rgb16_to_rgb15(void *d, void *s, int p, int);

void gray_to_rgb16(void *d, void *s, int p, int);
void rgb32_to_rgb16(void *d, void *s, int p, int);
void yuv422_to_rgb16(void *d, void *s, int p, int);
void yuv411_to_rgb16(void *d, void *s, int p, int);
void yuv411p_to_rgb16(void *d, void *s, int p, int w); /* needs width */
void yuv422p_to_rgb16(void *d, void *s, int p, int w);

void rgb15_to_rgb24(void *d, void *s, int p, int);
void rgb16_to_rgb24(void *d, void *s, int p, int);
void rgb32_to_rgb24(void *d, void *s, int p, int);
void rgb32_to_bgr24(void *d, void *s, int p, int);

void gray_to_rgb32(void *d, void *s, int p, int);
void rgb15_to_rgb32(void *d, void *s, int p, int);
void rgb16_to_rgb32(void *d, void *s, int p, int);
void yuv411p_to_rgb32(void *d, void *s, int p, int w);
void yuv422p_to_rgb32(void *d, void *s, int p, int w);

#ifdef __cplusplus
}
#endif

#endif





