/* 
    sound.h for Bt848 frame grabber driver

    Copyright (C) 1996,97 Marcus Metzler (mocm@thp.uni-koeln.de)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef _sound_h
#define _sound_h

#include <linux/soundcard.h>

#define LEFT 0
#define RIGHT 1

struct _lrvol {
  unsigned char l,r;
};

typedef _lrvol lr_vol;
  
class mixer
{
public:
  mixer(const char *filename="/dev/mixer", int device=SOUND_MIXER_LINE3);
  ~mixer(); 

  void set_vol(int l, int r=-1);
  void get_vol(int *v, int lr=LEFT);
  void setChannel(int _dev) { dev = _dev; }
  int getChannel() { return dev; }
  char *getNextChannelName(int *nr);
  void resetNextChannelName();
  int name2channel(const char *_devName);
  

private:
  int  mix;
  int  dev;
  int  volume;
  int  muted;
  int first;
  lr_vol m;
  int mixer_device;
  int devmask,recmask,recsrc,stereodevs,caps;
  int locked_channels, muted_channels;
};

#endif /* _sound_h */
/* DON'T ADD STUFF AFTER THIS #endif */





