/**********************************************************************

	--- Qt Architect generated file ---

	File: winTVsfData.h
	Last generated: Sun Mar 15 00:23:51 1998

	DO NOT EDIT!!!  This file will be automatically
	regenerated by qtarch.  All changes will be lost.

 *********************************************************************/

#ifndef wintvmainincluded
#define wintvmainincluded

#include <wintv.h>

#include <qpixmap.h>
#include <qtooltip.h>
//#include <qlcdnum.h>

#include <ctab.h>
#include <cselector.h>
#include <coptions.h>
#include <cfreq.h>

#include <otab.h>
#include <omixdev.h>

#include <kapp.h>
#include <kbutton.h>
#include <qpushbt.h>
#include <ktoolbar.h>
#include <ktopwidget.h>

#include <wintvscreen.h>
#include <lcddata.h>
#include <rcfile.h>
#include <channel.h>
#include <mixer.h>
#include <videoclip.h>

#ifdef myDEBUG
#define mainDEBUG
#endif

#define FRAME_NONE 0
#define FRAME_LEFT 1
#define FRAME_RIGHT 2
#define FRAME_UP 3
#define FRAME_DOWN 4

class winTVMainWidget : public KTopLevelWidget
{
  Q_OBJECT

public:
  winTVMainWidget(int argc = 0, char **argv = NULL, QWidget* parent = NULL,
		  const char* name = NULL, rcfile *_rc=NULL );
  ~winTVMainWidget();

  winTVScreenWidget *winTVScreenPtr() { return winTVScreen; }
  QPopupMenu *getAudioMenu() { return smenu; }
  QPopupMenu *getChannelMenu() { return chmenu; }
    
  void emitSetupSignals();

public slots:
  // audio & volume
  void audioModeChangedSLOT(int mode);
  void volumeUpSLOT();
  void volumeDownSLOT();
  void volumeSLOT(int vl, int vr);
  void splitSlidersSLOT();

  // channel selection
  void channelUpSLOT();
  void channelDownSLOT();
  void channelChangedSLOT(channel *ch);

  // channel managing
  void addChannelSLOT();
  void editChannelSLOT();
  void deleteChannelSLOT();

  // video clip
  void startVClipSLOT(struct MOVIE_PARAMS *);
  void endVClipSLOT();
  void frameVClipSLOT(int);
  void framelostVClipSLOT(int);
  void statVideoClipFrameSLOT(double);

protected slots:
  // buttonbar buttons and keys 
  void buttonsSLOT(int b);
  void keyPressedSLOT(int key);

  // menu bar
  void setupSLOT();
  void naSLOT();
  void videoClipSLOT();
  void propertiesSLOT();
  void captureToggleSLOT();
  void screenShotSLOT();
  void IRCoptionsSLOT();

  // audio: volume, mute, audio
  void soundSLOT();
  void audioAutoSLOT();
  void audioMonoSLOT();
  void audioStereoSLOT();
  void audioL1SLOT();
  void audioL2SLOT();

  // adjustments: aspect ratio and full screen 
  void adjustAspectRatioSLOT();
  void fullScreenSLOT();

  // translation
  //void translateChannelSLOT(int channel);
  
  // channel file actions 
  void saveChannelsSLOT();
  void saveChannelsAsSLOT();
  void loadChannelsSLOT();
  void importXAWTVChannelsSLOT();
  void importXTVSCREENChannelsSLOT();

  // ctab
  void defaultTabSLOT();
  void applyTabSLOT();
  void cancelTabSLOT();

  // mtab
  //void defaultMtabSLOT();
  void applyMtabSLOT();
  //void cancelMtabSLOT();

  // rc
  void saveRCSLOT();

  // menubar, toolbar
  void toggleToolBarSLOT();
  void toggleMenuBarSLOT();

  // info 
  void showChannelInfoSLOT(channel *ch);
  void unShowChannelInfoSLOT();
  void toggleChannelBoxSLOT();

  void vtxSLOT();

signals:
  void captureToggleSIGNAL(int);
  void audioModeChangedSIGNAL(int);
  void audioMuteToggledSIGNAL();
  void volumeChangedSIGNAL(int,int);
  void channelChangedSIGNAL(channel *);
  void toggleSplitSlidersSIGNAL();
  void newChannelListSIGNAL(channel *clist);
  void toggleChannelBoxSIGNAL();
  void toggleVClipSIGNAL();
  void frameVClipSIGNAL(int);
  void framelostVClipSIGNAL(int);
  void statVideoClipFrameSIGNAL(double);
  
protected:
  void resizeEvent( QResizeEvent * );
  void moveEvent( QMoveEvent * );
  //void updateRects ();

private:
  void saveChannels(const char *FILE);
  void loadChannels(const char *FILE);

private:
  winTVScreenWidget *winTVScreen;
  rcfile *rc;
  mixer *mix;

  // the toolbars
  KToolBar* toolbar;
  KMenuBar* menubar;
  QLCDNumber* lcd_channel;

  // dialogs
  ctab *tab;
  cselector *selector;
  coptions *options;
  cfreq *freq;

  // option dialogs
  otab *mtab;
  omixdev *mixdev;

  // cannel and country stuff
  channel *selchnl;     // the active channel
  channel channel_head; // the head of the channel list

  // pop ups --> KPopupMenu  
  QPopupMenu *tvmenu,*smenu,*chmenu;
  int smid[7];

  // info tools
  lcdData* channelLCD;
  int channelLCDpos;
  QTimer *infoTimer;

  // adjustments: aspect ratio and full screen 
  QRect oldPos;
  bool fullscreen;

  // stuff
  char filename[255];
  char *cnamep;
  int capture;

  bool fixed;

  bool wasEdit;
};

#endif wintvmainincluded




